interface Window {
    LoadingPanel: any;
}
declare module BA.Ui.Actions {
    /**
     * Class that contains all actions related to record collections.
     **/
    class RecordCollectionManagementActions {
        /**
         * Invokes the administrative dialog for creating a new folder.
         *
         * @param event the event delivered by the action control
         * @param customData the custom data delivered by the action control
         */
        static ClientActionClientActionCreateRecordCollection(event: any, customData: CustomData): void;
        /**
         * Invokes the administrative dialog for editing a new folder.
         *
         * @param event the event delivered by the action control
         * @param customData the custom data delivered by the action control
         */
        static ClientActionClientActionEditRecordCollection(event: any, customData: CustomData): void;
        /**
         * Invokes a warning message for deleting record collections and - depending on the user's answer - starts the
         * deletion of the selected record collections.
         *
         * @param event the event delivered by the action control
         * @param customData the custom data delivered by the action control
         */
        static ClientActionClientActionDeleteRecordCollection(event: any, customData: CustomData): void;
        /**
         * Callback method for GridView.GetSelectedFieldValues which is called in ClientActionClientActionDeleteRecordCollection.
         * Receives the keys of the selected record collections.
         *
         * @param keys the oids of the selected record collections
         */
        static ClientActionClientActionDeleteRecordCollectionGetKeysCallback(keys: any): void;
        /**
         * Eventually deletes the given record collections.
         *
         * @param keys array of guids of the selected record collections
         */
        static ClientActionClientActionDeleteRecordCollectionEventually(keys: any): void;
    }
}
