interface String {
    format(...replacements: string[]): string;
}
interface CustomData {
    [key: string]: Object;
}
interface TranslationDictionary {
    [key: string]: string;
}
interface GIConfiguration {
    base_url: string;
    app_base_url: string;
    start_page_url: string;
    current_user_id: string;
    attachmentEditSettingsDocx: string;
    attachmentEditSettingsXlsx: string;
    attachmentEditSettingsPdf: string;
    configurationName: string;
    configurationType: string;
}
declare class GridRowItem {
    RowOrmType: string;
    RowOrmOid: string;
    constructor(rowOrmType: string, rowOrmOid: string);
}
declare enum GridAmmountSelected {
    None = 0,
    One = 1,
    MoreThanOne = 2
}
interface BAClientFileManager extends MVCxClientFileManager {
    GetSelectedFile(): BAClientFileManagerFile;
    DeletedItems: any;
    cpAttachmentCaption: string;
    cpAttachments: any;
    cpTotalFileSize: any;
    cpShowFileSize: boolean;
    cpShowType: any;
    cpSingleClickFunction: any;
    cpClassName: string;
    cpControlPrefix: string;
    cpFieldName: string;
}
interface BAClientControl extends ASPxClientControl {
    /** Returns the popup control element this button belongs to */
    GetParentControl(): BAClientControl;
}
interface BAClientHtmlEditor extends MVCxClientHtmlEditor {
    OnPost(): any;
    cpFullToolbar: boolean;
}
interface BAClientRibbon extends ASPxClientRibbon {
    CustomData: {
        [key: string]: any;
    };
    items: any;
    cpCorrespondingGridViewName: string;
}
interface BAClientMenu extends ASPxClientMenu {
    IsVisible(): boolean;
}
interface BAClientRibbonItem extends ASPxClientRibbonItem {
    type: number;
    showPopup: Function;
    items: any[];
    info: any;
    ribbon: BAClientRibbon;
}
interface BAClientRibbonTab extends ASPxClientRibbonTab {
    getTabControlTab(): any;
}
interface BARibbonClientEvent extends ASPxClientEvent<ASPxClientRibbonCommandExecutedEventHandler<ASPxClientRibbon>> {
    removeHandlerByControlName(name: any): any;
}
interface BAClientGridViewCustomProperties extends MVCxClientGridView {
    cpADMoreResults: boolean;
    cpAllCombinedGrids: any;
    cpBreadCrumbCollectionJson: string;
    cpBreadCrumbDivID: string;
    cpClearSelectionOnSearch: boolean;
    cpConfiguredHeight: number;
    cpControlReadonly: boolean;
    cpDetailGrid: any;
    cpDnDType: string;
    cpDoubleClickFunction: any;
    cpDrillDownEnabled: boolean;
    cpDrillDownTypes: string;
    cpDuplicateSearchInformation: string;
    cpFilterExpression: string;
    cpFilterRecords: string[];
    cpFilterRelationDefinition: string;
    cpFilterRowVisible: boolean;
    cpFooterVisible: boolean;
    cpFormConfigurationGuid: string;
    cpGridCacheId: string;
    cpGridGuid: string;
    cpGridLayoutConfiguration: any;
    cpGridLayoutName: string;
    cpGridModelAdditionalData: string;
    cpGridsDataSources: string;
    cpGroupPanelVisible: boolean;
    cpHideGrid: boolean;
    cpIsAsControl: boolean;
    cpOpenBehavior: any;
    cpOverrideDoubleClickFunction: string;
    cpOverrideSingleClickFunction: string;
    cpPrimaryRecordGuid: string;
    cpRecordId: string;
    cpRelationToPrimaryRecord: string;
    cpSearchPanelFilter: string;
    cpSearchPanelVisible: boolean;
    cpShallowDeletionCheck: boolean;
    cpShowColumnHeaders: boolean;
    cpSingleClickFunction: any;
    cpTranslationGrid: string;
    cpTranslationGridSearch: string;
    cpNewPrimaryAdded: boolean;
    cpNoRibbon: boolean;
    cpRefreshEvents: string[];
    cpUpdateFields: string[];
    cpIsFolder: boolean;
}
interface BAClientGridBase {
    BAProperties: BA.Ui.Grid.Properties.BAGridProperties | BA.Ui.Grid.Properties.BACalendarProperties;
    cpAutoRefresh: boolean;
    cpIgniterResult: string;
    cpIsMainGrid: boolean;
    name: string;
    GetDataSourcesAsArray(): string[];
    GetDataSourcesAsString(): string;
    GetGridGuid(): string;
    GetSelectedRowCount(): number;
    GetSelectedKeysOnPage(): BA.Classes.Guid[] | string[];
}
interface BAClientGridView extends BAClientGridViewCustomProperties, BAClientGridBase {
    contextMenuHelper: any;
    deleteItemUrl: string;
    lastMultiSelectIndex: any;
    pageIndex: number;
    pageRowSize: number;
    pageRowCount: number;
    UA_UpdateEdit: any;
    ChangeItemStyle(visibleIndex: any, rowStyle: any): any;
    ContextMenuShowFilterRowMenu(p1: boolean): any;
    ContextMenuShowFilterRow(p1: any): any;
    ContextMenuShowFooter(visible: boolean): any;
    ContextMenuShowGroupPanel(visible: boolean): any;
    ContextMenuShowSearchPanel(boolean: any): any;
    DeselectItemByTypeAndOid(TypeAndOid: string[]): any;
    IsRowItemSelected(TypeAndOid: string[]): any;
    IsRowItemDeselected(TypeAndOid: string[]): any;
    EnableTokensInColumn(): any;
    ColumnsResized(): any;
    GetBAProperties(): BA.Ui.Grid.Properties.BAGridProperties;
    GetColumnIndexByDataCell(htmlTarget: any): number;
    GetCurrentPageIndices(): any;
    GetFilterRow(): any;
    GetKeyValues(): any;
    GetRow(index: number): HTMLElement;
    GetSearchEditor(): any;
    GetSelectedKeysOnPage(): BA.Classes.Guid[] | string[];
    HandleRowSelection(TypeAndOid: string[], selected: boolean): any;
    HightlightLastFixedColumn(): any;
    ResetSelections(): any;
    SelectItem(index: number, selected: boolean): any;
    SelectItemByTypeAndOid(TypeAndOid: string[]): any;
    SetBreadCrumbsForGrid(): any;
    UpdateItemVisibility(ev: ASPxClientEventArgs): any;
}
interface BAClientDetailGridMenu extends DevExpress.ui.dxMenu {
}
interface BAClientDetailGridMenuItem extends DevExpress.ui.dxMenuItem {
    name: string;
    icon: string;
    items: BAClientDetailGridMenuItem[];
    text: string;
    beginGroup: boolean;
    visible: boolean;
    disabled: boolean;
    ToolTip: string;
    AdditionalClientData: CustomData;
}
interface BAClientPopupControl extends MVCxClientPopupControl {
    cpMessage: string;
    cpButton: any;
    cpCaption: string;
    cpAllowResize: boolean;
    allowResize: boolean;
    cpShowFooter: boolean;
    cpIcon: any;
    CloseOnEscape: any;
    cpRefreshParentGrid: any;
    cpDialogTitle: string;
}
interface BAClientTreeList extends MVCxClientTreeList {
    cpTreeBuildingSources: any;
    GetRowByNodeKey(string: any): any;
    cpStartingType: any;
    FocusedNodeType: any;
    cpSetFocusToNodeKey: string;
}
interface BAClientCallbackPanel extends MVCxClientCallbackPanel {
    cpNotDirty: boolean;
    cpWarningMessage: string;
    cpContainingGrids: any;
    cpFields: string[];
    cpAdditionalOnChange: string;
    cpControlsWithCompanions: string[];
    cpCompanionsOfControls: string[];
    cpUpdateFields: string[];
    cpRefreshEvents: string[];
    cpRefreshGroupId: string;
    cpPostValues: string;
    cpViewStateRevision: number;
}
interface BAClientHiddenField extends ASPxClientHiddenField {
    GetValue(): any;
}
interface BAClientTokenBox extends MVCxClientTokenBox {
    cpAutoSubmit: any;
    UpdateStateHiddenField(): any;
    RaiseCloseUp(): void;
    GetTokenValuesCollection(): Array<string>;
    cpAllowCustomTokens: boolean;
    cpMaximumSelectionCount: number;
    cpFormConfigurationId: string;
    cpControlId: string;
}
interface BAClientComboBox extends MVCxClientComboBox {
    cpMutuallyExclusiveList: string;
    cpAutoSubmit: any;
    cpHasNavigateToConfigurationBtn: boolean;
    cpInitCanNavigateToConfiguration: boolean;
    cpOrmFieldName: string;
}
interface BAClientRadioButtonList extends ASPxClientRadioButtonList {
    cpSelectedItem: any;
    cpAdditionalOnChange: string;
}
interface BAClientFilterEditorProperty extends ASPxClientButtonEdit {
    cpOrmType: string;
    cpDialogTitle: string;
    cpIsLite: boolean;
    cpRawNames: boolean;
    cpHideRelated: boolean;
    cpOrmExists: boolean;
    GetErrorCell(): any;
}
interface BAClientButtonProperty extends ASPxClientButton {
    cpDialog: string;
    cpDefaultRecurring: boolean;
    cpCompanionField: string;
    cpDialogTitle: string;
    cpDialogCaption: string;
    cpModelType: string;
    cpFilterResource: string;
    cpFilterResourcePreselected: string;
    cpStartField: string;
    cpShowMessages: boolean;
    cpControlName: string;
}
interface BAClientDropDownEdit extends ASPxClientDropDownEdit {
    cpBaseName: string;
}
interface BAClientFilterEditor extends ASPxClientFilterControl {
    ChangeGroup(group: any, index: any): any;
    OnCallbackFinalized(): any;
    GetActiveCallbacksInfo(): any;
}
interface BAClientCheckBoxList extends ASPxClientCheckBoxList {
    cpSelectedItems: any;
    cpAutoSubmit: any;
}
interface BAClientListBox extends ASPxClientListBox {
    cpSelectedItems: any;
}
interface BAClientTextBox extends ASPxClientTextBox {
    cpCompanionField: string;
    CustomData: any;
}
interface BAClientFileManagerFile extends ASPxClientFileManagerFile {
    index: any;
    cpControlPrefix: string;
}
interface BAClientPanel extends ASPxClientPanel {
    updateDocumentPaddings(): any;
}
interface BAJQuery extends JQuery {
    matchHeight(p1: Object): any;
}
interface BAPickListSelectionGridInformation {
    SelectionGrid: string;
    FilterId: string;
    FilterRelation: string;
    FilterRelationCategory: string;
}
interface BASortableTokenBoxControl_AddToken {
    (oid: string, title: string, type: string, refocusInput?: boolean): void;
}
interface BAClientCheckBox extends ASPxClientCheckBox {
    cpAutoSubmit: boolean;
    cpAdditionalOnChange: string;
}
interface BAClientScheduler extends MVCxClientScheduler, BAClientGridBase {
    cpGridDataSources: any;
    cpGridsDataSources: any;
    cpConfigurationId: string;
    cpFormGuid: string;
    cpOpenBehavior: string;
    cpCanCreateNew: boolean;
    cpDurationEditable: boolean;
    cpCalendarLayoutConfiguration: string;
    cpCalendarLayoutName: string;
    cpFirstLoadOfLayoutConfig: boolean;
    cpShowStatusInToolTip: {
        [key: string]: boolean;
    };
    cpFilterResource: string;
    cpFilterStatus: string;
    cpFilterLabel: string;
    cpFilterSelectedStatus: string[];
    cpFilterSelectedLabel: string[];
    cpFilterSelectedResource: string[];
    cpResourceAsEnum: boolean;
    cpFilterStatusCaption: string;
    cpFilterLabelCaption: string;
    cpFilterResourceCaption: string;
    cpFilterResourceFieldName: string;
    cpFilterResourceDataTables: string;
    cpCalendarGroupType: string;
    cpDetailCalendarViewControlName: string;
    cpDetailCalendarViewRelation: string;
    cpDetailCalendarViewRelationCategory: string;
    cpInitTimeIntervals: {
        [key: string]: string;
    };
    cpAdditionalSettings: string;
    cpRecurrenceExceptionsAllowed: boolean;
    cpRefreshEvents: string[];
    cpUpdateFields: string[];
    cpDeleteOption: string;
    cpDeleteRelatedForRoles: string;
    cpOnlyDeleteRelatedInRecyclingBin: boolean;
    cpUserMayDeleteRelatedRecords: boolean;
    cpUserMayForceDeleteRelatedRecords: boolean;
    cpCurrentCalendarLayout: any;
    cpCanDragDropOrResize: boolean;
    AdjustHeight(): any;
    CanCreateNew(): boolean;
    CreateAppointment(formGuid: string, configuration: string, allday: boolean, start: Date, end: Date, resourceValue: string, openBehavior: string, detailCalendarRelation: string, cpDetailCalendarViewRelationCategory: string): any;
    FinishAppointment(formGuid: string, configuration: string, allday: boolean, start: Date, end: Date, resourceValue: string, openBehavior: string, detailCalendarRelation: string, cpDetailCalendarViewRelationCategory: string): any;
    FixDateFormat(): any;
    GetAppointmentById(id: string): BAClientAppointment;
    GetBAProperties(): BA.Ui.Grid.Properties.BACalendarProperties;
    HandleDragDropAndResize(dragInformation: ASPxClientAppointmentDragInfo[], e: any): any;
    HandleStatusOrLabelChanges(changeField: string, newEnumGuidString: string): any;
    HandleDelete(): any;
    InitFilterIcon(): any;
    IsAnySelectedRecurring(): boolean;
    IsFilterConfigured(): boolean;
    IsFilterActive(): boolean;
    LoadPermissionsForScheduler(): any;
    OpenRecordClientAction(): any;
    Refresh(): any;
    ScrollToFirstAppt(): any;
    UnselectAll(): any;
    UpdateEnabledTimeScale(newValue: string): any;
    UpdateFilterIconState(): any;
    UpdateVisibleTimeScale(newValue: string): any;
}
interface BAClientAppointment extends ASPxClientAppointment {
    cpExceptionId: string;
    cpDefaultFormGuid: string;
    cpOrmType: string;
    cpIsRecurring: boolean;
}
interface BASortableTokenBoxControl extends ASPxClientControl {
    AddToken: BASortableTokenBoxControl_AddToken;
    ClearNullText(): void;
    ContainsToken(oid: string): boolean;
    EmptyResultsList(): void;
    GetBackEndValue(): BA.Ui.Controls.Token[];
    GetBackEndValueRaw(): string;
    GetInputElement(): HTMLSpanElement;
    GetIsValid(): boolean;
    GetSelectedTokensFilter(): string;
    GetValue(): string;
    HideResultsContainer(): void;
    InternalGetDialogSelectionGridInformation(): BAPickListSelectionGridInformation[];
    IsResultsContainerShown(): boolean;
    RemoveToken(oid: string, focusInput: boolean): void;
    ResetInput(): void;
    ResetSearch(): void;
    SetBackEndValue(tokens: BA.Ui.Controls.Token[]): void;
    SetBackEndValueRaw(tokens: string): void;
    SetErrorText(text: string): void;
    SetIsValid(valid: boolean): void;
    SetValue(currentHtml: string): void;
    ShowResultsContainer(): void;
    SyncBackEndToUi(focusInput?: boolean): void;
    SyncUiToBackEnd(): void;
    cpControlId: string;
    cpFormConfigurationId: string;
    cpGridSelectionDisplayMode: string;
    cpDialogSelectionGrids: string[];
    cpFilterId: string;
    cpFilterRelationSubType: string;
    cpFilterRelationType: string;
    cpOverrideFilterIds: boolean;
    cpOnOpenerClicked: string;
    cpSearchControllerAndAction: string;
    cpSearchEnabled: boolean;
    cpShowIcon: boolean;
    cpSearchDisplayLines: number;
    cpMaxResultsToTake: number;
    cpSearchInDialogPosition: string;
    cpNullText: string;
    cpDialogTitle: string;
    cpDialogDescription: string;
    cpMinSelect: number;
    cpMaxSelect: number;
    cpSortable: boolean;
    mainElement: HTMLSpanElement;
}
interface BASearchIDControl extends ASPxClientControl {
    cpSearchControllerAndAction: string;
    cpFormConfigId: string;
    cpPicklistSelectionFieldName: string;
    cpTokenboxControlId: string;
    cpMaxResultsToTake: number;
    cpSearchIndexes: string;
    cpSearchFilter: string;
    cpAllowMultipleSelection: boolean;
}
interface Window {
    updateTabs: () => any;
    onShow: () => any;
    onHide: () => any;
    onRemove: () => any;
    toastr: Toastr;
    ProgressBar: any;
    FormContent: any;
    tabController: BA.Ui.TabController.Controller;
    translationTools: BA.Ui.Translations.TranslationTools;
    AddressGeocodeCache: {
        [key: string]: TempLatLng;
    };
    duplicateService: BA.Ui.Duplicates.DuplicateService;
    eventManager: BA.Ui.Event.EventManager;
    showNagScreen: boolean;
    tabProgressStyles: any;
    ButtonSubmit: ASPxClientButton;
    DialogButtonSubmit: ASPxClientButton;
    btnSubmitGridExport: ASPxClientButton;
    btnOk: ASPxClientButton;
    btnCancel: ASPxClientButton;
    btnDelete: ASPxClientButton;
    onResize: any;
    onReady: any;
    onAfterReady: any;
    onSaveSuccess: any;
    onSaveError: any;
    Historyjs: Historyjs;
    MessageBoxPopUp: BAClientPopupControl;
    Spreadsheet: MVCxClientSpreadsheet;
    TreeList: BAClientTreeList;
    RichEdit: MVCxClientRichEdit;
    Ribbon: BAClientRibbon;
    GridView: BAClientGridView;
    scheduler: BAClientScheduler;
    DesignTreeCallback: BAClientCallbackPanel;
    RecordCacheId: BAClientTextBox;
    ToolboxTreeList: BAClientTreeList;
    DesignTreeList: BAClientTreeList;
    FormTools: BA.Ui.Form.FormTools;
    FormTabTitle: HTMLInputElement;
    FormTabIcon: HTMLInputElement;
    ASPx: any;
    AttachmentDeletedAttachments: BAClientTextBox;
    activeDirectoryRecordsGrid: BAClientGridView;
    DestinationGrid: BAClientGridView;
    popupControl: BAClientPopupControl;
    NewRecordOid: BAClientHiddenField;
    giConfiguration: GIConfiguration;
    isOutlook: boolean;
    pdfManagement: BA.Ui.PDFManagement;
    ClientData: HTMLInputElement;
    SelectedForm: HTMLInputElement;
    temporaryKey: HTMLInputElement;
    Filter: BAClientTextBox;
    Configuration: BAClientTextBox;
    PropertiesPanel: BAClientCallbackPanel;
    HeaderPane: BAClientPanel;
    RibbonPane: BAClientPanel;
    Name: BAClientTextBox;
    Public: ASPxClientCheckBox;
    Default: ASPxClientCheckBox;
    TabLoadingPanel: ASPxClientLoadingPanel;
    Cookies: any;
    GlobalGMapsError: boolean;
}
declare function autoScroll(elements: any, options: any): any;
declare class TempLatLng {
    Lat: number;
    Lng: number;
    constructor(lat: number, lng: number);
}
